// More information about this indicator can be found at:
// http://fxcodebase.com/code/viewtopic.php?f=38&t=68338

//+------------------------------------------------------------------+
//|                               Copyright © 2019, Gehtsoft USA LLC | 
//|                                            http://fxcodebase.com |
//+------------------------------------------------------------------+
//|                                      Developed by : Mario Jemic  |
//|                                          mario.jemic@gmail.com   |
//+------------------------------------------------------------------+
//|                                 Support our efforts by donating  |
//|                                  Paypal : https://goo.gl/9Rj74e  |
//+------------------------------------------------------------------+
//|                                Patreon :  https://goo.gl/GdXWeN  |
//|                    BitCoin : 15VCJTLaz12Amr7adHSBtL9v8XomURo9RF  |
//|               BitCoin Cash : 1BEtS465S3Su438Kc58h2sqvVvHK9Mijtg  |
//|           Ethereum : 0x8C110cD61538fb6d7A2B47858F0c0AaBd663068D  |
//|                   LiteCoin : LLU8PSY2vsq7B9kRELLZQcKf5nJQrdeqwD  |
//+------------------------------------------------------------------+

#property copyright "Copyright © 2019, Gehtsoft USA LLC"
#property link      "http://fxcodebase.com"
#property strict

#property indicator_chart_window
#property indicator_buffers 5
#property strict

input ENUM_MA_METHOD ma1_method = MODE_EMA;  // MA 1 Method
input int            ma1_length = 8;         // MA 1 Length
input color          ma1_color  = clrGreen;  // MA 1 Color
input int            ma1_width  = 1;         // MA 1 Line Width
input int            ma1_shift  = 0;         // MA 1 Shift
input ENUM_MA_METHOD ma2_method = MODE_EMA;  // MA 2 Method
input int            ma2_length = 21;        // MA 2 Length
input color          ma2_color  = clrRed;    // MA 2 Color
input int            ma2_width  = 1;         // MA 2 Line Width
input int            ma2_shift  = 0;         // MA 2 Shift
input ENUM_MA_METHOD ma3_method = MODE_EMA;  // MA 3 Method
input int            ma3_length = 50;        // MA 3 Length
input color          ma3_color  = clrBlue;   // MA 3 Color
input int            ma3_width  = 1;         // MA 3 Line Width
input int            ma3_shift  = 0;         // MA 3 Shift
input ENUM_MA_METHOD ma4_method = MODE_EMA;  // MA 4 Method
input int            ma4_length = 200;       // MA 4 Length
input color          ma4_color  = clrYellow; // MA 4 Color
input int            ma4_width  = 1;         // MA 4 Line Width
input int            ma4_shift  = 0;         // MA 4 Shift
input ENUM_MA_METHOD ma5_method = MODE_EMA;  // MA 5 Method
input int            ma5_length = 800;       // MA 5 Length
input color          ma5_color  = clrBrown;  // MA 5 Color
input int            ma5_width  = 1;         // MA 5 Line Width
input int            ma5_shift  = 0;         // MA 5 Shift
extern int                btn_Subwindow = 0;
extern ENUM_BASE_CORNER   btn_corner            = CORNER_LEFT_UPPER;
extern string             btn_text              = "mas";
extern string             btn_Font              = "Arial";
extern int                btn_FontSize          = 8;
extern color              btn_text_ON_color     = clrLime;
extern color              btn_text_OFF_color    = clrRed;
extern color              btn_background_color  = clrDimGray;
extern color              btn_border_color      = clrBlack;
extern int                button_x              = 1100;
extern int                button_y              = 0;
extern int                btn_Width             = 60;

bool show_data = true;
bool recalc    = true;

string IndicatorName, IndicatorObjPrefix,buttonId;

double ma1[], ma2[], ma3[], ma4[], ma5[];

string GenerateIndicatorName(const string target) 
{
   string name = target;
   int try = 2;
   while (WindowFind(name) != -1)
   {
      name = target + " #" + IntegerToString(try++);
   }
   return name;
}

int OnInit()
{
IndicatorName = GenerateIndicatorName(btn_text);
   IndicatorObjPrefix = "__" + IndicatorName + "__";
   IndicatorShortName(IndicatorName);
   IndicatorDigits(Digits);
   
   double val;
   if (GlobalVariableGet(IndicatorName + "_visibility", val))
      show_data = val != 0; 
  //
  //
  //
           
 IndicatorBuffers(6);
    SetIndexBuffer(0, ma1);  SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,ma1_width,ma1_color); SetIndexShift(0,ma1_shift);
    SetIndexBuffer(1, ma2);  SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,ma2_width,ma2_color); SetIndexShift(1,ma2_shift);
    SetIndexBuffer(2, ma3);  SetIndexStyle(2,DRAW_LINE,STYLE_SOLID,ma3_width,ma3_color); SetIndexShift(2,ma3_shift);
    SetIndexBuffer(3, ma4);  SetIndexStyle(3,DRAW_LINE,STYLE_SOLID,ma4_width,ma4_color); SetIndexShift(3,ma4_shift);
    SetIndexBuffer(4, ma5);  SetIndexStyle(4,DRAW_LINE,STYLE_SOLID,ma5_width,ma5_color); SetIndexShift(4,ma5_shift);
   
   
    IndicatorSetString(INDICATOR_SHORTNAME," ma w button ");
    
      ChartSetInteger(0, CHART_EVENT_MOUSE_MOVE, 1);
   buttonId = IndicatorObjPrefix + (btn_text);
   createButton(buttonId, btn_text, btn_Width, 20, btn_Font, btn_FontSize, btn_background_color, btn_border_color, btn_text_ON_color);
   ObjectSetInteger(0, buttonId, OBJPROP_YDISTANCE, button_y);
   ObjectSetInteger(0, buttonId, OBJPROP_XDISTANCE, button_x);
   
  
 
return(INIT_SUCCEEDED);
}

void OnDeinit(const int reason)
{ 
 ObjectsDeleteAll(ChartID(), IndicatorObjPrefix);   
}
//
//
void createButton(string buttonID,string buttonText,int width,int height,string font,int fontSize,color bgColor,color borderColor,color txtColor)
  {
   ObjectDelete(0,buttonID);
      ObjectCreate (0,buttonID,OBJ_BUTTON,btn_Subwindow,0,0);
   ObjectSetInteger(0,buttonID,OBJPROP_COLOR,txtColor);
   ObjectSetInteger(0,buttonID,OBJPROP_BGCOLOR,bgColor);
   ObjectSetInteger(0,buttonID,OBJPROP_BORDER_COLOR,borderColor);
   ObjectSetInteger(0,buttonID,OBJPROP_BORDER_TYPE,BORDER_RAISED);
   ObjectSetInteger(0,buttonID,OBJPROP_XSIZE,width);
   ObjectSetInteger(0,buttonID,OBJPROP_YSIZE,height);
   ObjectSetString(0,buttonID,OBJPROP_FONT,font);
   ObjectSetString(0,buttonID,OBJPROP_TEXT,buttonText);
   ObjectSetInteger(0,buttonID,OBJPROP_FONTSIZE,fontSize);
   ObjectSetInteger(0,buttonID,OBJPROP_SELECTABLE,0);
   ObjectSetInteger(0,buttonID,OBJPROP_CORNER,btn_corner);
   ObjectSetInteger(0,buttonID,OBJPROP_HIDDEN,1);
   ObjectSetInteger(0,buttonID,OBJPROP_XDISTANCE,9999);
   ObjectSetInteger(0,buttonID,OBJPROP_YDISTANCE,9999);
  }
//+------------------------------------------------------------------+
void handleButtonClicks()
  {
   if(ObjectGetInteger(0, buttonId, OBJPROP_STATE))
     {
      ObjectSetInteger(0, buttonId, OBJPROP_STATE, false);
      show_data = !show_data;
      GlobalVariableSet(IndicatorName + "_visibility", show_data ? 1.0 : 0.0);
      recalc = true;
      // start();
     }
  }
//
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
  
 
	 handleButtonClicks();
   if(id==CHARTEVENT_OBJECT_CLICK && ObjectGet(sparam,OBJPROP_TYPE)==OBJ_BUTTON)
   
   for (int tp=0; tp<indicator_buffers; tp++)
            SetIndexStyle(tp,DRAW_LINE);

   if(show_data)
     {
      handleButtonClicks();
      ObjectSetInteger(ChartID(),buttonId,OBJPROP_COLOR,btn_text_ON_color);
        
        
     }
   else
     {
      ObjectSetInteger(ChartID(),buttonId,OBJPROP_COLOR,btn_text_OFF_color);
      
      for (int tp=0; tp<indicator_buffers; tp++)
            SetIndexStyle(tp,DRAW_NONE);
     
     }
 
	
}
//
//
//




int  OnCalculate(const int rates_total,const int prev_calculated,const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
{
   int i=rates_total-prev_calculated+1; if (i>=rates_total) i=rates_total-1; 
   
   //
   //
   //
   
   for (; i>=0 && !_StopFlag; i--)
   {
      ma1[i] = iMA(_Symbol,_Period,ma1_length,ma1_shift,ma1_method,PRICE_CLOSE,i);
      ma2[i] = iMA(_Symbol,_Period,ma2_length,ma2_shift,ma2_method,PRICE_CLOSE,i);
      ma3[i] = iMA(_Symbol,_Period,ma3_length,ma3_shift,ma3_method,PRICE_CLOSE,i);
      ma4[i] = iMA(_Symbol,_Period,ma4_length,ma4_shift,ma4_method,PRICE_CLOSE,i);
      ma5[i] = iMA(_Symbol,_Period,ma5_length,ma5_shift,ma5_method,PRICE_CLOSE,i);
   }
return(rates_total);
}

//
//
//


