//+------------------------------------------------------------------+
//|                                          Vertical Time Lines.mq4 |
//|                        Copyright 2014, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com 
//|
//| Author: File45
//+------------------------------------------------------------------+
#property copyright "Copyright 2014, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
#property strict
#property indicator_chart_window



#include <Controls/Button.mqh>

CButton B_ShowHideLines;
enum LW
{
   One = 1,
   Two = 2,
   Three = 3,
   Four = 4,
   Five = 5,
};   


enum TextPositions
{
  OnTop=1,
  OnBottom=2,
};
// DEFAULT INPUTS : START
//-----------------------------------------------------
input int Historical_Days = 10; // Historical days
  
input color  Line_1_Color = DodgerBlue; // Line 1  Color 
input bool   Line_1_Visible = true;     // Line 1  Visible
input string Line_1_Time = "00:30";     // Line 1  Time
input LW     Line_1_Width = 1;          // Line 1  Width
input ENUM_LINE_STYLE Line_1_Style = 2; // Line 1  Style

input color  Line_2_Color = DodgerBlue; // Line 2  Color
input bool   Line_2_Visible = true;     // Line 2  Visible
input string Line_2_Time = "07:00";     // Line 2  Time 
input LW     Line_2_Width = 1;          // Line 2  Width
input ENUM_LINE_STYLE Line_2_Style = 2; // Line 2  Style

input color  Line_3_Color = Magenta;    // Line 3  Color
input bool   Line_3_Visible = true;    // Line 3  Visible
input string Line_3_Time = "13:00";     // Line 3  Time
input LW     Line_3_Width = 1;          // Line 3  Width
input ENUM_LINE_STYLE Line_3_Style = 4; // Line 3  Style

input color  Line_4_Color = Magenta;    // Line 4  Color
input bool   Line_4_Visible = true;    // Line 4  Visible
input string Line_4_Time = "16:30";     // Line 4  Time
input LW     Line_4_Width = 1;          // Line 4  Width
input ENUM_LINE_STYLE Line_4_Style = 4; // Line 4  Style

input color  Line_5_Color = DarkOrange; // Line 5  Color
input bool   Line_5_Visible = true;    // Line 5  Visible
input string Line_5_Time = "20:00";     // Line 5  Time
input LW     Line_5_Width = 1;          // Line 5  Width
input ENUM_LINE_STYLE Line_5_Style = 2; // Line 5  Style

input color  Line_6_Color = DarkOrange; // Line 6  Color
input bool   Line_6_Visible = true;    // Line 6  Visible 
input string Line_6_Time = "21:00";     // Line 6  Time
input LW     Line_6_Width = 1;          // Line 6  Width
input ENUM_LINE_STYLE Line_6_Style = 2; // Line 6  Style  



input TextPositions TextPosition  = OnTop; 



 string Text_settings     = "___________________________________________";
 string Text_Font         = "Arial";
 int    Text_Size         = 10;
 double Text_Angle        = 90.0;
 int    Text_Distance     = 100;
 
//----------------------------------------------------- 
// DEFAULT INPUTS : END 

string T1_End = "Time_Line_1"; 
string T2_End = "Time_Line_2"; 
string T3_End = "Time_Line_3";  
string T4_End = "Time_Line_4"; 
string T5_End = "Time_Line_5";  
string T6_End = "Time_Line_6";    
 
void deinit() 
{
  DeleteObjects();
}

void CreateObjects(string no, color cl)
{
  ObjectCreate(no, OBJ_VLINE, 0, 0,0, 0,0);
 // ObjectSet(no, OBJPROP_WIDTH, Line_Width_1_2_3_4_or_5);
 // ObjectSet(no, OBJPROP_STYLE, Line_Style);
  ObjectSet(no, OBJPROP_COLOR, cl);
  ObjectSet(no, OBJPROP_BACK, true);
  
  
   ObjectCreate(0,"txt_"+no,OBJ_TEXT,0,0,0);
   ObjectSetString(0,"txt_"+no,OBJPROP_TEXT," ");
   ObjectSetString(0,"txt_"+no,OBJPROP_FONT,Text_Font);
   ObjectSetInteger(0,"txt_"+no,OBJPROP_FONTSIZE,Text_Size);
   ObjectSetDouble(0,"txt_"+no,OBJPROP_ANGLE,Text_Angle);
   ObjectSetInteger(0,"txt_"+no,OBJPROP_ANCHOR,ANCHOR_LEFT);
   ObjectSetInteger(0,"txt_"+no,OBJPROP_COLOR,cl);
   ObjectSetInteger(0,"txt_"+no,OBJPROP_BACK,false);
   ObjectSetInteger(0,"txt_"+no,OBJPROP_SELECTABLE,false);
   ObjectSetInteger(0,"txt_"+no,OBJPROP_SELECTED,false);
   ObjectSetInteger(0,"txt_"+no,OBJPROP_HIDDEN,false);
  
}

void DeleteObjects() 
{

  DeleteObjectsEu("txt_",4);
  ObjectDelete(0,"B_ShowHideLines");
  
  for (int i=0; i<Historical_Days; i++) 
  {
    ObjectDelete("T1"+IntegerToString(i));
    ObjectDelete("T2"+IntegerToString(i));
    ObjectDelete("T3"+IntegerToString(i));
    ObjectDelete("T4"+IntegerToString(i));
    ObjectDelete("T5"+IntegerToString(i));
    ObjectDelete("T6"+IntegerToString(i));
    

  }
}



void DeleteObjects2() 
{

  DeleteObjectsEu("txt_",4);
  
  
  for (int i=0; i<Historical_Days; i++) 
  {
    ObjectDelete("T1"+IntegerToString(i));
    ObjectDelete("T2"+IntegerToString(i));
    ObjectDelete("T3"+IntegerToString(i));
    ObjectDelete("T4"+IntegerToString(i));
    ObjectDelete("T5"+IntegerToString(i));
    ObjectDelete("T6"+IntegerToString(i));
    

  }
}

void DrawObjects(datetime dt, string no, string tb, string te) 
{
  datetime t1, t2;
  double   p1, p2;
  int      b1, b2,b3;

  t1=StrToTime(TimeToStr(dt, TIME_DATE)+" "+tb);
  t2=StrToTime(TimeToStr(dt, TIME_DATE)+" "+te);
  b1=iBarShift(NULL, 0, t1);
  b2=iBarShift(NULL, 0, t2);
  p1=High[Highest(NULL, 0, MODE_HIGH, b1-b2, b2)];
  p2=Low [Lowest (NULL, 0, MODE_LOW , b1-b2, b2)];
  ObjectSet(no, OBJPROP_TIME1 , t1);
  ObjectSet(no, OBJPROP_PRICE1, p1);
  ObjectSet(no, OBJPROP_TIME2 , t2);
  ObjectSet(no, OBJPROP_PRICE2, p2);
    
  Calc_Dist_Default();
   
  ObjectMove("txt_"+no, 0, t1-1 * Period() * 60, Dist_Default);
   
  ObjectSetString(0,"txt_"+no,OBJPROP_TEXT,TimeToStr(t1,TIME_MINUTES));
  ObjectSetString(0,"txt_"+no,OBJPROP_TOOLTIP,TimeToStr(t1,TIME_MINUTES));
}

datetime decDateTradeDay (datetime dt) 
{
  int ty=TimeYear(dt);
  int tm=TimeMonth(dt);
  int td=TimeDay(dt);
  int th=TimeHour(dt);
  int ti=TimeMinute(dt);

  td--;
  if (td==0) 
  {
    tm--;
    if (tm==0) 
    {
      ty--;
      tm=12;
    }
    if (tm==1 || tm==3 || tm==5 || tm==7 || tm==8 || tm==10 || tm==12) td=31;
    if (tm==2) if (MathMod(ty, 4)==0) td=29; else td=28;
    if (tm==4 || tm==6 || tm==9 || tm==11) td=30;
  }
  return(StrToTime(IntegerToString(ty)+"."+IntegerToString(tm)+"."+IntegerToString(td)+" "+IntegerToString(th)+":"+IntegerToString(ti)));
}

bool   ViewLines =false;

void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
 
   if(id==CHARTEVENT_CHART_CHANGE)
     {
        
       if(ViewLines)
         {
          Calc_Dist_Default();
          Calc();
         
         }

       
     }


   if(id==CHARTEVENT_OBJECT_CLICK&&sparam=="B_ShowHideLines")
    {
    if(ViewLines==false)
      {
      
          InitCreateObject();
          Calc_Dist_Default();
          Calc();
          ViewLines=true;
      }
    else
      {
         DeleteObjects2();
         ViewLines=false;
      }
    
    
    }
 
 
 
   }


datetime dt;
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
 {

   
   if(NewDay())
     {
     
       if(ViewLines)
          {
          Calc_Dist_Default();
          Calc();        
          }
       else
          {
           DeleteObjects2();
          }   

     }
   //
   return(rates_total);
}

void Calc()
{
   dt=CurTime();

   for (int i=0; i<Historical_Days; i++) 
   {
      if(Line_1_Visible == true)
      {
         DrawObjects(dt, "T1"+IntegerToString(i), Line_1_Time, T1_End);
      }
      if(Line_2_Visible == true)
      {
         DrawObjects(dt, "T2"+IntegerToString(i), Line_2_Time, T2_End);
      }
      if(Line_3_Visible == true)
      {
         DrawObjects(dt, "T3"+IntegerToString(i), Line_3_Time, T3_End);
      }
      if(Line_4_Visible == true)
      {
         DrawObjects(dt, "T4"+IntegerToString(i), Line_4_Time, T4_End);
      }
      if(Line_5_Visible == true)
      {
         DrawObjects(dt, "T5"+IntegerToString(i), Line_5_Time, T5_End);
      }
      if(Line_6_Visible == true)
      {
         DrawObjects(dt, "T6"+IntegerToString(i), Line_6_Time, T6_End);
      }
        
      dt=decDateTradeDay(dt);
      while (TimeDayOfWeek(dt)>5) dt=decDateTradeDay(dt);
      
   }
} 

string NameObj;

void DeleteObjectsEu(string TextInNameOfObjects, int count)
{

for(int i = ObjectsTotal() -1 ;i >= 0; i--)
   {
     NameObj = ObjectName(i);
     if (StringSubstr(NameObj, 0, count) == TextInNameOfObjects)
             {
                 ObjectDelete(NameObj);
             }
   }
}


static datetime today;
bool NewDay(){

if (today != iTime (Symbol(), PERIOD_D1, 0))
   {
   today = iTime (Symbol(), PERIOD_D1, 0);
   //showinfo("Its a new day " + TimeToStr(iTime (Symbol(), PERIOD_D1, 0)), 0,100);
   return true;
   }
else
   {
    return false;
   }

}



double Dist_Default;
void Calc_Dist_Default()
{

if(TextPosition==OnTop)
Dist_Default=WindowPriceMax()-((WindowPriceMax()-WindowPriceMin())/12);
else
Dist_Default=WindowPriceMin()+((WindowPriceMax()-WindowPriceMin())/12);
}

int OnInit()
{

   
  DeleteObjects();
  InitCreateObject();

   int X1=1; 
   int Y1=100; 
   int X2=X1+40;
   int Y2=Y1+25;
   
   
   B_ShowHideLines.Create(0,"B_ShowHideLines",0,X1,Y1,X2,Y2);
   B_ShowHideLines.Text("Show");
   B_ShowHideLines.ColorBackground(clrBlack);
   B_ShowHideLines.ColorBorder(clrWhite);
   B_ShowHideLines.Color(clrWhite);   
   ObjectSetString(0, "B_ShowHideLines", OBJPROP_TOOLTIP, "Show Hide Lines");
   
   return(INIT_SUCCEEDED);
}



void InitCreateObject()
{
for (int i=0; i<Historical_Days; i++) 
  {
     CreateObjects("T1"+ IntegerToString(i), Line_1_Color);
     ObjectSet("T1"+IntegerToString(i), OBJPROP_WIDTH, Line_1_Width);
     ObjectSet("T1"+IntegerToString(i), OBJPROP_STYLE, Line_1_Style);
     
     CreateObjects("T2"+IntegerToString(i), Line_2_Color);
     ObjectSet("T2"+IntegerToString(i), OBJPROP_WIDTH, Line_2_Width);
     ObjectSet("T2"+IntegerToString(i), OBJPROP_STYLE, Line_2_Style);
     
     CreateObjects("T3"+IntegerToString(i), Line_3_Color);
     ObjectSet("T3"+IntegerToString(i), OBJPROP_WIDTH, Line_3_Width);
     ObjectSet("T3"+IntegerToString(i), OBJPROP_STYLE, Line_3_Style);
     
     CreateObjects("T4"+IntegerToString(i), Line_4_Color);
     ObjectSet("T4"+IntegerToString(i), OBJPROP_WIDTH, Line_4_Width);
     ObjectSet("T4"+IntegerToString(i), OBJPROP_STYLE, Line_4_Style);
     
     CreateObjects("T5"+IntegerToString(i), Line_5_Color);
     ObjectSet("T5"+IntegerToString(i), OBJPROP_WIDTH, Line_5_Width);
     ObjectSet("T5"+IntegerToString(i), OBJPROP_STYLE, Line_5_Style);
     
     CreateObjects("T6"+IntegerToString(i), Line_6_Color);
     ObjectSet("T6"+IntegerToString(i), OBJPROP_WIDTH, Line_6_Width);
     ObjectSet("T6"+IntegerToString(i), OBJPROP_STYLE, Line_6_Style);
  }


}

 




  